package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.pojo.PageParam;
import com.zt.plat.framework.common.util.object.BeanUtils;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigQCSampleMethodParameterDO;
import com.zt.plat.module.qms.business.config.dal.mapper.ConfigQCSampleMethodParameterMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.diffList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.*;

/**
 * 质控样检测方法参数配置 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class ConfigQCSampleMethodParameterServiceImpl implements ConfigQCSampleMethodParameterService {

    @Resource
    private ConfigQCSampleMethodParameterMapper configQCSampleMethodParameterMapper;

    @Override
    public ConfigQCSampleMethodParameterRespVO createConfigQCSampleMethodParameter(ConfigQCSampleMethodParameterSaveReqVO createReqVO) {
        // 插入
        ConfigQCSampleMethodParameterDO configQCSampleMethodParameter = BeanUtils.toBean(createReqVO, ConfigQCSampleMethodParameterDO.class);
        configQCSampleMethodParameterMapper.insert(configQCSampleMethodParameter);
        // 返回
        return BeanUtils.toBean(configQCSampleMethodParameter, ConfigQCSampleMethodParameterRespVO.class);
    }

    @Override
    public void updateConfigQCSampleMethodParameter(ConfigQCSampleMethodParameterSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigQCSampleMethodParameterExists(updateReqVO.getId());
        // 更新
        ConfigQCSampleMethodParameterDO updateObj = BeanUtils.toBean(updateReqVO, ConfigQCSampleMethodParameterDO.class);
        configQCSampleMethodParameterMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigQCSampleMethodParameter(Long id) {
        // 校验存在
        validateConfigQCSampleMethodParameterExists(id);
        // 删除
        configQCSampleMethodParameterMapper.deleteById(id);
    }

    @Override
        public void deleteConfigQCSampleMethodParameterListByIds(List<Long> ids) {
        // 校验存在
        validateConfigQCSampleMethodParameterExists(ids);
        // 删除
        configQCSampleMethodParameterMapper.deleteByIds(ids);
        }

    private void validateConfigQCSampleMethodParameterExists(List<Long> ids) {
        List<ConfigQCSampleMethodParameterDO> list = configQCSampleMethodParameterMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(CONFIG_QC_SAMPLE_METHOD_PARAMETER_NOT_EXISTS);
        }
    }

    private void validateConfigQCSampleMethodParameterExists(Long id) {
        if (configQCSampleMethodParameterMapper.selectById(id) == null) {
            throw exception(CONFIG_QC_SAMPLE_METHOD_PARAMETER_NOT_EXISTS);
        }
    }

    @Override
    public ConfigQCSampleMethodParameterDO getConfigQCSampleMethodParameter(Long id) {
        return configQCSampleMethodParameterMapper.selectById(id);
    }

    @Override
    public PageResult<ConfigQCSampleMethodParameterDO> getConfigQCSampleMethodParameterPage(ConfigQCSampleMethodParameterPageReqVO pageReqVO) {
        return configQCSampleMethodParameterMapper.selectPage(pageReqVO);
    }

}